package routes

import (
	"encoding/json"
	"gitea.deepak.science/deepak/gogmagog/models"
	"github.com/go-chi/chi"
	"net/http"
	"strconv"
)

func newUserRouter(m *models.Model) http.Handler {
	router := chi.NewRouter()
	// router.Post("/", postUserFunc(m))
	router.Get("/{userid}", getUserByIDFunc(m))
	return router
}

func getUserByIDFunc(m *models.Model) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		id, err := strconv.Atoi(chi.URLParam(r, "userid"))
		if err != nil {
			notFoundHandler(w, r)
			return
		}
		user, err := m.User(id)
		if err != nil {
			if models.IsNotFoundError(err) {
				notFoundHandler(w, r)
				return
			}
			serverError(w, err)
			return

		}
		w.Header().Add("Content-Type", "application/json")
		if err := json.NewEncoder(w).Encode(user); err != nil {
			serverError(w, err)
		}
	}
}
